import { openBlock as c, createElementBlock as f, createElementVNode as h, renderSlot as d, createStaticVNode as I, Fragment as x, renderList as C, h as L, resolveComponent as k, withKeys as B, normalizeStyle as T, mergeProps as m, toHandlers as V, createVNode as R, createSlots as X, withCtx as g, createBlock as W, normalizeProps as y, guardReactiveProps as P, createCommentVNode as S, toDisplayString as M } from "vue";
const $ = (e, t) => {
  const s = e.__vccOpts || e;
  for (const [i, r] of t)
    s[i] = r;
  return s;
}, E = {
  props: {
    index: {
      type: Number
    },
    pages: {
      type: Number
    },
    shouldLoop: {
      type: Boolean
    }
  },
  computed: {
    // Determine if button should be disabled because we're at the limits
    backDisabled() {
      return this.index === 0 && !this.shouldLoop;
    },
    nextDisabled() {
      return this.index === this.pages - 1 && !this.shouldLoop;
    }
  }
}, A = { class: "ssr-carousel-arrows" }, N = ["disabled"], O = ["disabled"];
function U(e, t, s, i, r, n) {
  return c(), f("div", A, [
    h("button", {
      class: "ssr-carousel-back-button",
      "aria-label": "Back",
      disabled: n.backDisabled,
      onClick: t[0] || (t[0] = (a) => e.$emit("back"))
    }, [
      d(e.$slots, "back", { disabled: n.backDisabled }, () => [
        t[2] || (t[2] = I('<span class="ssr-carousel-back-icon"><svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="1.5" stroke-linecap="round" stroke-linejoin="round" class="icon icon-tabler icons-tabler-outline icon-tabler-arrow-narrow-left"><path stroke="none" d="M0 0h24v24H0z" fill="none"></path><path d="M5 12l14 0"></path><path d="M5 12l4 4"></path><path d="M5 12l4 -4"></path></svg></span>', 1))
      ])
    ], 8, N),
    h("button", {
      class: "ssr-carousel-next-button",
      "aria-label": "Next",
      disabled: n.nextDisabled,
      onClick: t[1] || (t[1] = (a) => e.$emit("next"))
    }, [
      d(e.$slots, "next", { disabled: n.nextDisabled }, () => [
        t[3] || (t[3] = I('<span class="ssr-carousel-next-icon"><svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="1.5" stroke-linecap="round" stroke-linejoin="round" class="icon icon-tabler icons-tabler-outline icon-tabler-arrow-narrow-right"><path stroke="none" d="M0 0h24v24H0z" fill="none"></path><path d="M5 12l14 0"></path><path d="M15 16l4 -4"></path><path d="M15 8l4 4"></path></svg></span>', 1))
      ])
    ], 8, O)
  ]);
}
const F = /* @__PURE__ */ $(E, [["render", U]]), G = {
  props: {
    boundedIndex: {
      type: Number
    },
    pages: {
      type: Number
    }
  },
  methods: {
    // Check if dot index should be disabled
    isDisabled(e) {
      return this.boundedIndex === e - 1;
    }
  }
}, q = { class: "ssr-carousel-dots" }, j = ["aria-label", "disabled", "onClick"];
function z(e, t, s, i, r, n) {
  return c(), f("div", q, [
    (c(!0), f(x, null, C(s.pages, (a) => (c(), f("button", {
      class: "ssr-carousel-dot-button",
      key: a,
      "aria-label": `Page ${a}`,
      disabled: n.isDisabled(a),
      onClick: (p) => e.$emit("goto", a - 1)
    }, [
      d(e.$slots, "dot", {
        index: a,
        disabled: n.isDisabled(a)
      }, () => [
        t[0] || (t[0] = h("span", { class: "ssr-carousel-dot-icon" }, null, -1))
      ])
    ], 8, j))), 128))
  ]);
}
const H = /* @__PURE__ */ $(G, [["render", z]]), D = "a, button, input, textarea, select", v = (e) => {
  if (!e.children || typeof e.children == "string")
    return e.children || "";
  if (Array.isArray(e.children))
    return v(e.children);
  if (e.children.default)
    return v(e.children.default);
}, K = {
  props: {
    dragging: {
      type: Boolean
    },
    trackTranslateX: {
      type: Number
    },
    slideOrder: {
      type: Array
    },
    activeSlides: {
      type: Array
    },
    leftPeekingSlideIndex: {
      type: Number
    },
    rightPeekingSlideIndex: {
      type: Number
    }
  },
  // Set tabindex of inactive slides on mount
  mounted() {
    this.denyTabIndex(this.inactiveSlides), this.denyTabIndex(this.clonedSlides);
  },
  computed: {
    // Get the count of non-cloned slides
    uniqueSlidesCount() {
      return this.slideOrder.length;
    },
    // Get the total slides count, including clones
    allSlidesCount() {
      return this.getSlideComponents().length;
    },
    // Make an array of inactive slide indices
    // Make an array of inactive slide indices
    inactiveSlides() {
      return Array.from(
        { length: this.uniqueSlidesCount },
        (e, t) => t
      ).filter((e) => !this.activeSlides.includes(e));
    },
    // An array of the cloned slides indices
    clonedSlides() {
      return Array.from(
        { length: this.allSlidesCount - this.uniqueSlidesCount },
        (e, t) => t + this.uniqueSlidesCount
      );
    },
    // Styles that are used to position the track
    styles() {
      if (this.trackTranslateX)
        return {
          transform: `translateX(${this.trackTranslateX}px)`
        };
    }
  },
  // Update the tabindex of interactive elements when slides change
  watch: {
    activeSlides() {
      this.allowTabIndex(this.activeSlides), this.denyTabIndex(this.inactiveSlides);
    }
  },
  methods: {
    makeSlides() {
      return this.getSlideComponents().map((e, t) => {
        const s = this.uniqueSlidesCount, i = t >= s, r = t - s;
        let {
          class: n = "",
          style: a = {},
          attrs: p = {}
        } = e.props || {}, u = e.key;
        const o = "ssr-carousel-slide";
        return n += n ? ` ${o}` : o, i ? a.order = r === this.leftPeekingSlideIndex ? "-1" : r === this.rightPeekingSlideIndex ? this.slideOrder.length : void 0 : a.order = this.slideOrder[t] || 0, i && ![this.leftPeekingSlideIndex, this.rightPeekingSlideIndex].includes(
          r
        ) && (a.display = "none"), (i || !this.activeSlides.includes(t)) && (p["aria-hidden"] = "true"), i && u && (u += `-clone-${t}`), e.key = u, e.props = {
          ...e.props,
          class: n,
          style: a,
          ...p
        }, e;
      });
    },
    getDefaultSlides(e) {
      return e.reduce((t, s) => (s.type === x ? Array.isArray(s.children) && (t = [...t, ...this.getDefaultSlides(s.children)]) : t.push(s), t), []);
    },
    // Get the list of non-text slides, including peeking clones. This doesn't
    // work as a computed function
    getSlideComponents() {
      var s, i;
      const e = this.getDefaultSlides(this.$slots.default() || []), t = this.getDefaultSlides(((i = (s = this.$slots).clones) == null ? void 0 : i.call(s)) || []);
      return [...e, ...t].filter(
        (r) => !v(r)
      );
    },
    // Prevent tabbing to interactive elements in slides with the passed in
    // index values
    denyTabIndex(e) {
      this.setTabIndex(e, -1);
    },
    // Allow tabindex on interactive elements in slides with the passed in
    // index values
    allowTabIndex(e) {
      this.setTabIndex(e, 0);
    },
    // Set tabindex value on interactive elements in slides with the passed in slides
    setTabIndex(e, t) {
      for (const s of this.getSlideElementsByIndices(e))
        s.matches(D) && (s.tabIndex = t), s.querySelectorAll(D).forEach((i) => {
          i.tabIndex = t;
        });
    },
    // Get the slide elements that match the array of indices
    getSlideElementsByIndices(e) {
      return Array.from(this.$el.children).filter((t, s) => s in e);
    }
  },
  render() {
    return L(
      "div",
      {
        class: ["ssr-carousel-track", { dragging: this.dragging }],
        style: this.styles
      },
      this.makeSlides()
    );
  }
}, Q = (
  // Store whether the user appears to be using keyboard to navigate
  {
    data() {
      return { usingKeyboard: !1 };
    },
    computed: {
      // Make the current slide message
      // https://www.w3.org/WAI/tutorials/carousels/functionality/#announce-the-current-item
      currentSlideMessage() {
        return `Item ${this.boundedIndex + 1} of ${this.pages}`;
      }
    },
    watch: {
      // When switching to keyboard navigation, I could never reproduce a scenario
      // where the focused elements wasn't the first slide, so I'm resetting the
      // active page to the first slide
      usingKeyboard() {
        if (this.usingKeyboard)
          return this.goto(0);
      }
    },
    methods: {
      // Once a user uses tab on the carousel, mark them as using their keyboard.
      // This is cleared by the onPointerDown method.
      onTab() {
        return this.usingKeyboard = !0;
      }
    }
  }
), _ = {
  props: {
    // A delay provided in seconds for the autoplay. 0 is disabled
    autoplayDelay: {
      type: Number,
      default: 0
    },
    // Should we pause on hover
    pauseOnFocus: {
      type: Boolean,
      default: !0
    }
  },
  // Start autolaying on mount
  mounted() {
    this.autoplayStart();
  },
  beforeDestroy() {
    this.autoplayStop();
  },
  computed: {
    // Conditions that result in pausing autoplay
    autoplayPaused() {
      if (this.usingKeyboard)
        return !0;
      if (this.pauseOnFocus)
        return this.windowHidden || this.isFocused;
    }
  },
  watch: {
    autoplayPaused(e) {
      e ? this.autoplayStop() : this.autoplayStart();
    }
  },
  methods: {
    autoplayStart() {
      this.autoplayDelay && this.pages && (this.autoPlayInterval = setInterval(() => {
        this.autoplayPaused || this.autoplayNext();
      }, this.autoplayDelay * 1e3));
    },
    autoplayStop() {
      clearInterval(this.autoPlayInterval);
    },
    autoplayNext() {
      this.shouldLoop || this.index < this.pages - 1 ? this.next() : this.goto(0);
    }
  }
}, Y = {
  data() {
    return {
      viewportWidth: null,
      // Width of the viewport, for media query calculation
      carouselWidth: null,
      // Width of a page of the carousel
      gutterWidth: 0
      // Computed width of gutters, since they support css vars
    };
  },
  // Add resize listening
  mounted() {
    this.onResize(), window.addEventListener("resize", this.onResize);
  },
  // Cleanup listeners
  beforeDestroy() {
    window.removeEventListener("resize", this.onResize);
  },
  computed: {
    // The width of a page of slides, which may be less than the carouselWidth
    // if there is peeking. This includes the affect of gutters.
    pageWidth() {
      return this.carouselWidth - this.combinedPeek;
    },
    // Calculate the width of a slide based on client side measured pageWidth
    // rather than measuring it explicitly in the DOM. This value includes the
    // gutter.
    slideWidth() {
      return this.pageWidth / this.currentSlidesPerPage;
    },
    // Calculate the width of the whole track from the slideWidth.
    trackWidth() {
      return this.isVariableWidth ? this.measuredTrackWidth + this.gutterWidth : this.slideWidth * this.slidesCount;
    },
    // Figure out the width of the last page, which may not have enough slides
    // to fill it.
    lastPageWidth() {
      const e = this.currentSlidesPerPage;
      let t = this.slidesCount % e;
      return t === 0 && (t = e), t * this.slideWidth;
    },
    // The ending x value, only used when not looping. The peeking values in
    // here result in the final page using the left peeking value and the
    // actualy peeking appearing to apply to the left. The +1 is to fix subpixel
    // rounding issues.
    endX() {
      return this.disabled ? 0 : this.pageWidth - this.trackWidth - this.peekLeftPx + this.peekRightPx + 1;
    },
    // Check if the drag is currently out bounds
    isOutOfBounds() {
      return this.currentX > 0 || this.currentX < this.endX;
    }
  },
  methods: {
    // Measure the component width for various calculations. Using
    // getBoundingClientRect so we can get fractional values.  We also need
    // the width of the gutter since that's effectively part of the page.
    onResize() {
      var t, s;
      if (!((t = this.$el) != null && t.nodeType) === Node.ELEMENT_NODE)
        return;
      const e = (s = this.$refs.track) == null ? void 0 : s.$el.firstElementChild;
      e && (this.gutterWidth = parseInt(getComputedStyle(e).marginRight), this.carouselWidth = this.$el.getBoundingClientRect().width + this.gutterWidth, this.viewportWidth = window.innerWidth, this.capturePeekingMeasurements(), this.isVariableWidth && this.captureTrackWidth());
    },
    // Make the width style that gives a slide it's width given
    // slidesPerPage. Reduce this width by the gutter if present
    makeBreakpointSlideWidthStyle(e) {
      if (!this.isVariableWidth)
        return `
        ${this.scopeSelector} .ssr-carousel-slide {
          width: ${this.makeSlideWidthCalc(e)};
        }
      `;
    },
    // Build the calc string which makes a percentage width for a slide and
    // reduces it by combined peeking and gutter influence. The computed
    // style this produces should have an equal value to the `slideWidth`
    // computed property which is client side JS dependent.
    makeSlideWidthCalc(e) {
      const t = this.isDisabledAtBreakpoint(e), s = this.getResponsiveValue(
        "slidesPerPage",
        e
      ), i = this.getResponsiveValue("gutter", e);
      let r = this.getResponsiveValue("peekLeft", e), n = this.getResponsiveValue("peekRight", e);
      return this.matchPeekWhenDisabled && t && (n = r), `calc(
				${100 / s}% -
				(${this.autoUnit(r)} + ${this.autoUnit(n)}) / ${s} -
				(${this.autoUnit(i)} * ${s - 1}) / ${s}
			)`;
    }
  }
}, l = { passive: !0 }, w = { passive: !1 }, J = {
  props: {
    // Boundary drag dampening modifier. Increase to allow greater travel outside the boundaries.
    boundaryDampening: {
      type: Number,
      default: 0.6
    },
    // The percentage of a pageWidth that was dragged before we advance to another page on slide
    dragAdvanceRatio: {
      type: Number,
      default: 0.33
    },
    // The ratio of X:Y mouse travel. Decrease this number to allow for greater y dragging before the drag is cancelled.
    verticalDragTreshold: {
      type: Number,
      default: 1
    },
    // Turn off draggability
    noDrag: {
      type: Boolean
    }
  },
  data() {
    return {
      pressing: !1,
      // The user pressing pointer down
      dragging: !1,
      // The user has translated while pointer was down
      isTouchDrag: !1,
      // Is the browser firing touch events
      startPointer: null,
      // Where was the mouse when the drag started
      lastPointer: null,
      // Where was the mouse on the last move event
      dragVelocity: null,
      // The px/tick while dragging, negative is rightward
      dragDirectionRatio: null
      // The ratio of horizontal vs vertical dragging
    };
  },
  // Cleanup listeners
  beforeDestroy() {
    window.removeEventListener("mousemove", this.onPointerMove, l), window.removeEventListener("mouseup", this.onPointerUp, l), window.removeEventListener("touchmove", this.onPointerMove, l), window.removeEventListener("touchend", this.onPointerUp, l), window.removeEventListener("touchmove", this.onWinMove, w);
  },
  computed: {
    // The current slide or page index. It rounds differently depending on the direction of the velocity.
    // So that it eases to a stop in the direction the user was dragging.
    dragIndex() {
      return Math.abs(this.dragVelocity) <= 2 ? Math.round(this.fractionalIndex) : this.dragVelocity < 0 ? Math.ceil(this.fractionalIndex) : Math.floor(this.fractionalIndex);
    },
    // Determine the current index given the currentX as a fraction. For instance, when dragging forward,
    // it will be like 0.1 and when you've dragged almost a full page, forward it would be 0.9.
    // This got complicated because the final page may not have a full compliment of slides like if we have 2 per page and 3 slides.
    fractionalIndex() {
      if (!this.trackWidth) return 0;
      let e = this.currentX * -1, t = Math.floor(e / this.trackWidth), s = this.paginateBySlide ? this.slideWidth : this.pageWidth, i = Math.floor(
        (e - t * this.trackWidth) / s
      ), r = e - t * this.trackWidth - i * s, n = this.currentSlidesPerPage, u = (this.shouldLoop ? this.slidesCount - i * n : this.slidesCount - (i + 1) * n) <= n ? this.lastPageWidth : s;
      return r / u + t * this.pages + i;
    },
    // Determine if the user is dragging vertically
    isVerticalDrag() {
      return this.dragDirectionRatio ? this.dragDirectionRatio < this.verticalDragTreshold : !1;
    },
    // If we're horizontally swiping on a touch device, prevent vertical scroll
    preventVerticalScroll() {
      return this.pressing && this.isTouchDrag && !this.isVerticalDrag;
    }
  },
  watch: {
    // Watch for mouse move changes when the user starts dragging
    pressing() {
      let e, t;
      this.isTouchDrag ? [e, t] = ["touchmove", "touchend"] : [e, t] = ["mousemove", "mouseup"], this.pressing ? (window.addEventListener(e, this.onPointerMove, l), window.addEventListener(t, this.onPointerUp, l), window.addEventListener("contextmenu", this.onPointerUp, l), this.dragVelocity = 0, this.preventContentDrag(), this.stopTweening()) : (this.isOutOfBounds && !this.shouldLoop ? this.currentX >= 0 ? this.gotoStart() : this.gotoEnd() : this.isVariableWidth ? this.tweenToStop() : this.isVerticalDrag ? this.goto(this.index) : this.goto(this.dragIndex), window.removeEventListener(e, this.onPointerMove, l), window.removeEventListener(t, this.onPointerUp, l), window.removeEventListener("contextmenu", this.onPointerUp, l), this.dragging = !1, this.startPointer = this.lastPointer = this.dragDirectionRatio = null), this.pressing ? this.$emit("press") : this.$emit("release");
    },
    // Fire events related to dragging
    dragging() {
      this.dragging ? this.$emit("drag:start") : this.$emit("drag:end");
    },
    // If the user is dragging vertically, end the drag based on the assumption
    // that the user is attempting to scroll the page via touch rather than pan the carousel.
    isVerticalDrag() {
      !this.isVerticalDrag && this.isTouchDrag && (this.pressing = !1);
    },
    // Stop vertical scrolling by listening for touchmove events on the body and cancel them.
    // Need to explicitly set passive because some mobile browsers set it to true by default.
    preventVerticalScroll(e) {
      e ? window.addEventListener("touchmove", this.stopEvent, w) : window.removeEventListener("touchmove", this.stopEvent, w);
    }
  },
  methods: {
    // Cancel an Event
    stopEvent(e) {
      e.preventDefault();
    },
    // Keep track of whether the user is dragging
    onPointerDown(e) {
      this.isTouchDrag = window.TouchEvent && e instanceof TouchEvent, this.startPointer = this.lastPointer = this.getPointerCoords(e), this.pressing = !0, this.usingKeyboard = !1;
    },
    // Keep track of release of press
    onPointerUp() {
      this.pressing = !1;
    },
    // Keep x values up to date while dragging
    onPointerMove(e) {
      this.dragging = !0;
      let t = this.getPointerCoords(e);
      this.dragVelocity = t.x - this.lastPointer.x, this.targetX += this.dragVelocity, this.lastPointer = t, this.dragDirectionRatio = Math.abs(
        (t.x - this.startPointer.x) / (t.y - this.startPointer.y)
      ), this.currentX = this.applyBoundaryDampening(this.targetX);
    },
    // Helper to get the x position of either a touch or mouse event
    getPointerCoords(e) {
      var t, s, i, r;
      return {
        x: ((s = (t = e.touches) == null ? void 0 : t[0]) == null ? void 0 : s.pageX) || e.pageX,
        y: ((r = (i = e.touches) == null ? void 0 : i[0]) == null ? void 0 : r.pageY) || e.pageY
      };
    },
    // Prevent dragging from exceeding the min/max edges
    applyBoundaryDampening(e) {
      return this.shouldLoop ? e : e > 0 ? Math.pow(e, this.boundaryDampening) : e < this.endX ? this.endX - Math.pow(this.endX - e, this.boundaryDampening) : this.applyXBoundaries(e);
    },
    // Constraint the x value to the min and max values
    applyXBoundaries(e) {
      return this.shouldLoop ? e : Math.max(this.endX, Math.min(0, e));
    },
    // Prevent the anchors and images from being draggable (like via their ghost outlines).
    // Using this approach because the draggable HTML attribute didn't work in FF.
    // This only needs to be run once.
    preventContentDrag() {
      this.contentDragPrevented || !this.$refs.track || (this.$refs.track.$el.querySelectorAll("a, img").forEach((e) => {
        e.addEventListener("dragstart", (t) => {
          t.preventDefault();
        });
      }), this.contentDragPrevented = !0);
    }
  }
}, Z = {
  props: {
    // Shorthand for enabling boolean and setting its width
    feather: {
      type: [Boolean, String, Number],
      default: !1
    }
  },
  methods: {
    // Add feathering styles via breakpoint
    makeBreakpointFeatheringStyle(e) {
      if (this.isDisabledAtBreakpoint(e)) return;
      let t = this.getResponsiveValue("feather", e);
      if (t === !1 || t === null) return;
      t = t && typeof t != "boolean" ? t : 20, t = this.autoUnit(t);
      let s = `
        linear-gradient(to right,
          transparent, black ${t},
          black calc(100% - ${t}),
          transparent)
      `;
      return `
        ${this.scopeSelector} .ssr-carousel-mask {
          -webkit-mask-image: ${s};
          mask-image: ${s};
        }
      `;
    }
  }
}, ee = {
  data() {
    return {
      hovered: !1,
      windowVisible: !0
    };
  },
  computed: {
    isFocused() {
      return this.windowVisible && this.hovered;
    },
    windowHidden() {
      return !this.windowVisible;
    }
  },
  methods: {
    onEnter() {
      this.hovered = !0;
    },
    onLeave() {
      this.hovered = !1;
    },
    updateVisibility() {
      this.windowVisible = !document.hidden;
    }
  },
  mounted() {
    this.watchesHover && document.addEventListener("visibilitychange", this.updateVisibility);
  },
  beforeDestroy() {
    document.removeEventListener("visibilitychange", this.updateVisibility);
  }
}, te = {
  props: {
    // The gutters between slides
    gutter: {
      type: [Number, String],
      default: 20
    }
  },
  methods: {
    // Apply gutters between slides via margins
    makeBreakpointSlideGutterStyle(e) {
      const t = this.getResponsiveValue("gutter", e), s = this.isDisabledAtBreakpoint(e) ? 0 : t;
      return `
        ${this.scopeSelector} .ssr-carousel-slide {
          margin-right: ${this.autoUnit(t)};
        }
        ${this.scopeSelector} .ssr-carousel-slide:is(:last-child) {
          margin-right: ${this.autoUnit(s)};
        }
      `;
    }
  }
}, se = {
  props: {
    // Add prop to enable looping
    loop: Boolean,
    // Place the first slide in the center of the layout
    center: Boolean
  },
  data() {
    return {
      slideOrder: []
    };
  },
  computed: {
    // Disable looping when the user is using keyboard navigation
    shouldLoop() {
      return this.loop && !this.usingKeyboard;
    },
    // This represents the current (as in while scrolling / animating) left most
    // slide index. This is used in looping calculation so that the reordering
    // of slides isn't affected by paginatePerSlide setting.
    currentSlideIndex() {
      return Math.floor(this.currentX / this.slideWidth * -1);
    },
    // When looping, slides get re-ordered. This value is added to the
    // track transform so that the slides don't feel like they were re-ordered.
    trackLoopOffset() {
      if (!this.shouldLoop) return 0;
      let e = this.currentSlideIndex;
      return this.hasLeftPeekClone && (e -= 1), e * this.slideWidth;
    },
    // Get slideIndex of the right most and left most slides indexes
    leftMostSlideIndex() {
      return this.slideOrder.findIndex((e) => e === 0);
    },
    rightMostSlideIndex() {
      return this.slideOrder.findIndex(
        (e) => e === this.slideOrder.length - 1
      );
    }
  },
  watch: {
    // This represents the current (as in while scrolling / animating) left most
    // slide index. This is used in looping calculation so that the reordering
    // of slides isn't affected by paginatePerSlide setting.
    currentSlideIndex: {
      immediate: !0,
      handler() {
        this.setSlideOrder();
      }
    },
    // Also update the slide order when the slides per page changes
    currentSlidesPerPage() {
      this.setSlideOrder();
    }
  },
  methods: {
    // Calculating via watcher to prevent unnecessary recalculations (I noticed a
    // bunch of calls when this was done via a computed property)
    setSlideOrder() {
      let e = [...Array(this.slidesCount).keys()], t = e.length;
      if (this.center) {
        let s = Math.floor(this.currentSlidesPerPage / 2);
        e = [...e.slice(s), ...e.slice(0, s)];
      }
      if (this.shouldLoop) {
        let s = (t - this.currentSlideIndex) % t;
        e = [...e.slice(s), ...e.slice(0, s)];
      }
      this.slideOrder = e;
    },
    // Reorder the initial slide state using CSS because the order is dependent
    // on the slides per page which isn't known via JS until hydrating
    makeBreakpointSlideOrderStyle(e) {
      if (!this.center) return;
      let t = this.getResponsiveValue("slidesPerPage", e), s = Math.floor(t / 2), i = [];
      for (let r = 0; r <= this.slidesCount; r++)
        i.push(`
          ${this.scopeSelector} .ssr-carousel-slide:nth-child(${r + 1}) {
            order: ${(r + s) % this.slidesCount};
          }
        `);
      return i.join("");
    }
  }
}, b = (e) => {
  if (!e.children || typeof e.children == "string")
    return e.children || "";
  if (Array.isArray(e.children))
    return b(e.children);
  if (e.children.default)
    return b(e.children.default());
}, ie = {
  props: {
    // If true, advance whole pages when navigating
    paginateBySlide: Boolean,
    // Syncs to the `index` value via v-model
    modelValue: {
      type: Number,
      default: 0
    }
  },
  data() {
    return {
      index: this.modelValue,
      // The current page; when looping may exceed slideCount
      currentX: 0,
      // The actual left offset of the slides container
      targetX: 0
      // Where we may be tweening the slide to
    };
  },
  computed: {
    // The current number of pages
    pages() {
      return this.paginateBySlide ? this.shouldLoop ? this.slidesCount : this.slidesCount - this.currentSlidesPerPage + 1 : Math.ceil(this.slidesCount / this.currentSlidesPerPage);
    },
    // Disable carousel-ness when there aren't enough slides
    disabled() {
      return this.isVariableWidth ? Math.round(this.trackWidth) <= Math.round(this.carouselWidth) : this.slidesCount <= this.currentSlidesPerPage;
    },
    // Get just the slotted slides that are components, ignoring text nodes
    // which may exist as a result of whitespace
    slides() {
      return this.getDefaultSlides(this.$slots.default()) || [].filter((e) => !b(e));
    },
    // Get the total number of slides
    slidesCount() {
      return this.slides.length;
    },
    // Apply boundaries to the index, which will exceed them when looping
    boundedIndex() {
      const e = this.index % this.pages;
      return e < 0 ? this.pages + e : e;
    },
    // The current incomplete page offset
    currentIncompletePageOffset() {
      return this.makeIncompletePageOffset(this.index);
    },
    // Get an array of slide offsets of the slides that are 100% in the
    // viewport. Aka, the count will be equal the currentSlidesPerPage per page.
    activeSlides() {
      if (this.isVariableWidth)
        return [...Array(this.slidesCount).keys()];
      let e = this.paginateBySlide ? this.boundedIndex : this.boundedIndex * this.currentSlidesPerPage;
      this.shouldLoop || (e -= this.boundedIndex % this.currentSlidesPerPage);
      const t = [];
      for (let s = e; s < e + this.currentSlidesPerPage; s++)
        t.push(s);
      return t.reduce((s, i) => (this.shouldLoop ? s.push(i % this.slidesCount) : i < this.slidesCount && s.push(i), s), []);
    }
  },
  watch: {
    // Treat v-model update:modelValue as a "goto" request
    modelValue() {
      this.modelValue !== this.applyIndexBoundaries(this.modelValue) ? this.$emit("update:modelValue", this.boundedIndex) : this.modelValue !== this.boundedIndex && this.goto(this.modelValue);
    },
    // Emit events on index change
    boundedIndex() {
      this.$emit("change", { index: this.boundedIndex }), this.$emit("update:modelValue", this.boundedIndex);
    }
  },
  methods: {
    getDefaultSlides(e) {
      return e.reduce((t, s) => (s.type === x ? Array.isArray(s.children) && (t = [...t, ...this.getDefaultSlides(s.children)]) : t.push(s), t), []);
    },
    // Advance methods
    next() {
      this.goto(this.index + 1);
    },
    back() {
      this.goto(this.index - 1);
    },
    // The dots are ignorant of looping, so convert their bounded index to the
    // true index so we don't animate through a ton of pages going to the
    // clicked dot.
    gotoDot(e) {
      this.goto(e - this.boundedIndex + this.index);
    },
    // Go to a specific index
    goto(e) {
      this.index = this.applyIndexBoundaries(e), this.tweenToIndex(this.index);
    },
    // Go to the beginning of track
    gotoStart() {
      this.isVariableWidth ? this.tweenToX(0) : this.goto(0);
    },
    // Go to the end of the track
    gotoEnd() {
      this.isVariableWidth ? this.tweenToX(this.endX) : this.goto(this.pages - 1);
    },
    // Tween to a specific index
    tweenToIndex(e) {
      this.targetX = this.getXForIndex(e), this.startTweening();
    },
    // Jump to an index with no tween
    jumpToIndex(e) {
      this.currentX = this.targetX = this.getXForIndex(e);
    },
    // Calculate the X value given an index
    getXForIndex(e) {
      let t = this.paginateBySlide ? e * this.slideWidth * -1 : e * this.pageWidth * -1;
      return t += this.makeIncompletePageOffset(e), Math.round(this.applyXBoundaries(t));
    },
    // Creates a px value to represent adjustments that should be made to
    // account for incomplete pages of slides when looping is enabled. Like
    // when there are 3 slotted slides and 2 slides per page and you have looped
    // over to the 2nd page index of 0. The track needs to be shifted to the
    // left by one slideWidth in this case.
    makeIncompletePageOffset(e) {
      if (!(this.shouldLoop && !this.paginateBySlide))
        return 0;
      const t = this.pageWidth - this.lastPageWidth;
      return Math.floor(e / this.pages) * t;
    },
    // Apply boundaries to the index
    applyIndexBoundaries(e) {
      return this.shouldLoop ? e : Math.max(0, Math.min(this.pages - 1, e));
    }
  }
}, re = {
  props: {
    // Use gutter's as the peeking value
    peekGutter: Boolean,
    // Set both peeking values at once
    peek: {
      type: [Number, String],
      default(e) {
        return e.peekGutter ? `calc(${e.gutter} - 1px)` : 0;
      }
    },
    // Distinct left/right peeking values
    peekLeft: {
      type: [Number, String],
      default(e) {
        return e.peek;
      }
    },
    peekRight: {
      type: [Number, String],
      default(e) {
        return e.peek;
      }
    },
    // When true, the peekLeft is used for the peekRight if the carousel is
    // disabled.  This behavior is expecting that there may be a different
    // peekRight (to hint at additional slides) but when there
    // aren't more slide to peek in, the peek value should functional like padding.
    matchPeekWhenDisabled: {
      type: Boolean,
      default: !0
    },
    // Disable the overflow:hidden on the mask
    overflowVisible: Boolean
  },
  data() {
    return {
      // Store clones of the slides used for peeking
      clones: [],
      // Store computed peek values
      peekLeftPx: 0,
      peekRightPx: 0
    };
  },
  computed: {
    // Determine if clones should be created
    hasPeekClones() {
      return this.hasLeftPeekClone || this.hasRightPeekClone;
    },
    hasPeekPrerequisites() {
      return this.shouldLoop && this.slidesCount > 1;
    },
    hasLeftPeekClone() {
      return this.hasPeekPrerequisites && this.peekLeft;
    },
    hasRightPeekClone() {
      return this.hasPeekPrerequisites && this.peekRight;
    },
    // Figure out which slide indexes to show in the left and right peek slots
    leftPeekingSlideIndex() {
      if (this.hasLeftPeekClone)
        return this.rightMostSlideIndex;
    },
    rightPeekingSlideIndex() {
      if (this.hasRightPeekClone)
        return this.leftMostSlideIndex;
    },
    // Combine the peeking values, which is needed commonly
    combinedPeek() {
      return this.peekLeftPx + this.peekRightPx;
    },
    // Make the styles object for reading computed styles
    peekStyles() {
      const e = this.currentResponsiveBreakpoint;
      return {
        left: this.autoUnit(this.getResponsiveValue("peekLeft", e)),
        right: this.autoUnit(this.getResponsiveValue("peekRight", e))
      };
    }
  },
  watch: {
    // Recapture peeking values if the source props change
    peekLeft() {
      this.capturePeekingMeasurements();
    },
    peekRight() {
      this.capturePeekingMeasurements();
    },
    peek() {
      this.capturePeekingMeasurements();
    },
    peekGutter() {
      this.capturePeekingMeasurements();
    },
    responsive() {
      this.capturePeekingMeasurements();
    }
  },
  methods: {
    // Capture measurements of peeking values
    capturePeekingMeasurements() {
      if (!this.$refs.peekValues) return;
      const e = getComputedStyle(this.$refs.peekValues);
      this.peekLeftPx = parseInt(e.left), this.peekRightPx = parseInt(e.right);
    },
    // Calculate the offset that gets added to the current position to account
    // for prepended slides from peeking. This replicates the JS required to
    // make `trackLoopOffset` using CSS only so there is now reflow when JS
    // hydrates.  This gets overridden by the track's inline translateX style.
    makeBreakpointTrackTransformStyle(e) {
      if (this.isDisabledAtBreakpoint(e)) return;
      const t = this.getResponsiveValue("peekLeft", e);
      let s;
      if (!this.hasLeftPeekClone)
        s = `transform: translateX(${this.autoUnit(t)});`;
      else {
        const i = this.getResponsiveValue("gutter", e);
        s = `transform: translateX(calc(${this.autoUnit(
          t
        )} - (${this.makeSlideWidthCalc(e)} + ${this.autoUnit(
          i
        )})));`;
      }
      return `${this.scopeSelector} .ssr-carousel-track { ${s} }`;
    }
  }
}, ne = {
  props: {
    // How many slides are visible at once in the viewport if no responsive
    // rules apply
    slidesPerPage: {
      type: Number,
      default: 1
    },
    // Provide different slides per page at different viewport widths
    responsive: {
      type: Array,
      default: () => []
    }
  },
  computed: {
    // Make the css scopeId from things that can influence the styles, like the
    // slides count and props.
    scopeId() {
      return this.hashString(
        this.slidesCount + "|" + JSON.stringify(this.$props)
      );
    },
    // Massage media queries into the responsive prop
    responsiveRules() {
      return this.responsive.map((e) => ({
        ...e,
        mediaQuery: this.makeMediaQuery(e),
        active: this.isBreakpointActive(e),
        peekLeft: e.peekLeft || e.peek || e.gutter && e.peekGutter,
        peekRight: e.peekRight || e.peek || e.gutter && e.peekGutter
      }));
    },
    // Get current responsive values
    currentSlidesPerPage() {
      return this.getResponsiveValue(
        "slidesPerPage",
        this.currentResponsiveBreakpoint
      );
    },
    // Get the current responsive rule by looping backwards through the
    // responsiveRules to return the last matching rule.
    currentResponsiveBreakpoint() {
      const t = [...this.responsiveRules].reverse().find(({ active: s }) => s);
      return t || {
        slidesPerPage: this.slidesPerPage,
        gutter: this.gutter,
        peekLeft: this.peekLeft || this.peek || this.gutter && this.peekGutter,
        peekRight: this.peekRight || this.peek || this.gutter && this.peekGutter,
        feather: this.feather
      };
    },
    // Make the scoping selector
    scopeSelector() {
      return `[data-ssrc-id='${this.scopeId}']`;
    },
    // Assemble all the dynamic instance styles
    instanceStyles() {
      return "<style>" + this.makeBreakpointStyles(this.$props) + this.responsiveRules.map((e) => `@media ${e.mediaQuery} {
              ${this.makeBreakpointStyles(e)}
            }`).join(" ") + "</style>";
    }
  },
  watch: {
    // Fix alignment of slides while resizing
    pageWidth() {
      this.jumpToIndex(this.index);
    },
    // If resizing the browser leads to disabling, reset the slide to the first
    // page.  Like if a user had switched to the 2nd page on mobile and then
    // resized to desktop
    disabled() {
      this.disabled && this.goto(0);
    }
  },
  methods: {
    // Take an item from the responsive array and make a media query from it
    makeMediaQuery(e) {
      const t = [];
      return e.maxWidth && t.push(`(max-width: ${e.maxWidth}px)`), e.minWidth && t.push(`(min-width: ${e.minWidth}px)`), t.join(" and ");
    },
    // Make the block of styles for a breakpoint
    makeBreakpointStyles(e) {
      return [
        this.makeBreakpointDisablingRules(e),
        this.makeBreakpointFeatheringStyle(e),
        this.makeBreakpointTrackTransformStyle(e),
        this.makeBreakpointSlideWidthStyle(e),
        this.makeBreakpointSlideGutterStyle(e),
        this.makeBreakpointSlideOrderStyle(e)
      ].join(" ");
    },
    // Apply disabling styles via breakpoint when there are not enough slides
    // for the slidesPerPage
    makeBreakpointDisablingRules(e) {
      const t = this.getResponsiveValue(
        "slidesPerPage",
        e
      );
      return this.slidesCount <= t ? `
          ${this.scopeSelector} .ssr-carousel-track { justify-content: center; }
          ${this.scopeSelector} .ssr-carousel-arrows,
          ${this.scopeSelector} .ssr-carousel-dots { display: none; }
        ` : `
          ${this.scopeSelector} .ssr-carousel-track { justify-content: start; }
          ${this.scopeSelector} .ssr-carousel-arrows { display: block; }
          ${this.scopeSelector} .ssr-carousel-dots { display: flex; }
        `;
    },
    // Check if carousel disabled at the breakpoint
    isDisabledAtBreakpoint(e) {
      const t = this.getResponsiveValue(
        "slidesPerPage",
        e
      );
      return this.slidesCount <= t;
    },
    // Check if a breakpoint would apply currently. Not using window.matchQuery
    // so I can consume via a computed property
    isBreakpointActive(e) {
      return !this.viewportWidth || e.maxWidth && this.viewportWidth > e.maxWidth ? !1 : !(e.minWidth && this.viewportWidth < e.minWidth);
    },
    // Find the first breakpoint with a property set
    getResponsiveValue(e, t) {
      if (t[e] !== void 0) return t[e];
      if (!this.responsiveRules.length) return this[e];
      const s = this.responsiveRules.find((i) => {
        if (i[e] && (t.maxWidth && i.minWidth && i.minWidth < t.maxWidth || t.maxWidth && i.maxWidth && i.maxWidth < t.maxWidth || t.minWidth && i.minWidth && i.minWidth > t.minWidth || t.minWidth && i.maxWidth && i.minWidth > t.minWidth))
          return !0;
      });
      return s ? s[e] : this[e];
    },
    // Make a hash from a string, adapted from:
    // https://stackoverflow.com/a/33647870/59160
    hashString(e) {
      let t = 0;
      for (let s = 0, i = e.length; s < i; s++)
        t = (t << 5) - t + e.charCodeAt(s) << 0;
      return t.toString(36);
    },
    // Add px unit to a value if numeric
    autoUnit(e) {
      return e ? String(e).match(/^[\d\-.]+$/) ? `${e}px` : e : "0px";
    }
  }
}, ae = {
  props: {
    tweenDampening: {
      type: Number,
      default: 0.12
    },
    tweenInertia: {
      type: Number,
      default: 3
    }
  },
  data() {
    return {
      currentX: 0,
      targetX: 0,
      tweening: !1,
      rafId: null
    };
  },
  beforeDestroy() {
    window.cancelAnimationFrame(this.rafId);
  },
  watch: {
    tweening() {
      this.tweening ? (this.$emit("tween:start", { index: this.index }), this.tweenToTarget()) : (window.cancelAnimationFrame(this.rafId), this.$emit("tween:end", { index: this.index }));
    }
  },
  methods: {
    tweenToX(e) {
      this.targetX = Math.round(e), this.startTweening();
    },
    startTweening() {
      this.tweening || this.currentX !== this.targetX && (this.tweening = !0);
    },
    stopTweening() {
      this.tweening = !1;
    },
    tweenToTarget() {
      this.currentX = this.currentX + (this.targetX - this.currentX) * this.tweenDampening, Math.abs(this.targetX - this.currentX) < 1 ? (this.currentX = this.targetX, this.tweening = !1) : this.rafId = window.requestAnimationFrame(this.tweenToTarget);
    },
    tweenToStop() {
      this.targetX = this.applyXBoundaries(
        this.currentX + this.dragVelocity * this.tweenInertia
      ), this.startTweening();
    }
  }
}, oe = {
  data() {
    return {
      measuredTrackWidth: 0
    };
  },
  computed: {
    isVariableWidth() {
      return this.slidesPerPage == null;
    }
  },
  methods: {
    captureTrackWidth() {
      this.$refs.track && (this.measuredTrackWidth = this.$refs.track.$el.scrollWidth);
    }
  }
}, le = {
  // eslint-disable-next-line vue/multi-word-component-names
  name: "Carousel",
  mixins: [
    Q,
    _,
    Y,
    J,
    Z,
    ee,
    te,
    se,
    ie,
    ne,
    re,
    // After `responsive` so prop can access `gutter` prop
    ae,
    oe
  ],
  components: {
    CarouselArrows: F,
    CarouselDots: H,
    CarouselTrack: K
  },
  emits: [
    "update:modelValue",
    "tween:start",
    "tween:end",
    "drag:start",
    "drag:end",
    "change",
    "release",
    "press"
  ],
  props: {
    showArrows: {
      type: Boolean
    },
    showDots: {
      type: Boolean
    }
  },
  computed: {
    // Combine the different factors that come together to determine the x
    // transform of the track.  We don't return a value until the carousel
    // width is measured since the calculation depends on that.
    trackTranslateX() {
      if (this.carouselWidth && !this.disabled)
        return this.currentX + // The value from tweening or dragging
        this.trackLoopOffset + // Offset from re-ordering slides for looping
        this.peekLeftPx;
    },
    watchesHover() {
      return this.autoplayDelay > 0;
    },
    maskListeners() {
      return this.disabled ? {} : {
        ...this.noDrag ? {} : {
          mousedown: this.onPointerDown,
          touchstart: this.onPointerDown
        },
        ...this.watchesHover ? {
          mouseenter: this.onEnter,
          mouseleave: this.onLeave
        } : {}
      };
    }
  }
}, he = ["data-ssrc-id"], de = ["innerHTML"], ue = { class: "ssr-carousel-slides" }, ce = {
  class: "ssr-carousel-visually-hidden",
  "aria-live": "polite",
  "aria-atomic": "true"
};
function pe(e, t, s, i, r, n) {
  const a = k("CarouselTrack"), p = k("CarouselArrows"), u = k("CarouselDots");
  return e.$slots.default() && e.$slots.default().length ? (c(), f("div", {
    class: "ssr-carousel",
    key: e.$slots.default().length,
    "data-ssrc-id": e.scopeId,
    onKeyup: t[0] || (t[0] = B((...o) => e.onTab && e.onTab(...o), ["tab"]))
  }, [
    h("span", { innerHTML: e.instanceStyles }, null, 8, de),
    h("div", ue, [
      h("div", {
        class: "ssr-peek-values",
        ref: "peekValues",
        style: T(e.peekStyles)
      }, null, 4),
      h("div", m({
        class: "ssr-carousel-mask",
        ref: "mask"
      }, V(n.maskListeners, !0), {
        class: {
          pressing: e.pressing,
          disabled: e.disabled,
          "no-mask": e.overflowVisible,
          "not-draggable": e.noDrag
        }
      }), [
        R(a, m({ ref: "track" }, {
          dragging: e.dragging,
          trackTranslateX: n.trackTranslateX,
          slideOrder: e.slideOrder,
          activeSlides: e.activeSlides,
          leftPeekingSlideIndex: e.leftPeekingSlideIndex,
          rightPeekingSlideIndex: e.rightPeekingSlideIndex
        }), X({
          default: g(() => [
            d(e.$slots, "default")
          ]),
          _: 2
        }, [
          e.hasPeekClones ? {
            name: "clones",
            fn: g(() => [
              d(e.$slots, "default")
            ]),
            key: "0"
          } : void 0
        ]), 1040)
      ], 16),
      s.showArrows ? (c(), W(p, m({ key: 0 }, { index: e.index, pages: e.pages, shouldLoop: e.shouldLoop }, {
        onBack: e.back,
        onNext: e.next
      }), {
        back: g((o) => [
          d(e.$slots, "back-arrow", y(P(o)))
        ]),
        next: g((o) => [
          d(e.$slots, "next-arrow", y(P(o)))
        ]),
        _: 3
      }, 16, ["onBack", "onNext"])) : S("", !0),
      s.showDots ? (c(), W(u, m({ key: 1 }, { boundedIndex: e.boundedIndex, pages: e.pages }, { onGoto: e.gotoDot }), {
        dot: g((o) => [
          d(e.$slots, "dot", y(P(o)))
        ]),
        _: 3
      }, 16, ["onGoto"])) : S("", !0),
      h("div", ce, M(e.currentSlideMessage), 1)
    ])
  ], 40, he)) : S("", !0);
}
const fe = /* @__PURE__ */ $(le, [["render", pe]]);
export {
  fe as default
};
//# sourceMappingURL=vue3-ssr-carousel.es.js.map
